%
%   INVPNNL1.M   Nonlinear model of inverted pendulum (ODE function file format)
%
%   See documentation of equations in Section VII of Dynamic Systems Notes
%
%   File prepared by J. R. White, UMass-Lowell (last update: March 2020).
%

      function zdot = invpnnl1(t,z,u,M,m,g,len)
      zdot = zeros(size(z));
      c1 = (M+m);  c2 = m*len;  c3 = m*g;  c4 = (M+m)*len;  c5 = (M+m)*g;
      zdot(1) = z(2);
      top2 = u*cos(z(1)) - c5*sin(z(1)) + c2*cos(z(1))*sin(z(1))*z(2)^2;
      zdot(2) = top2/(c2*cos(z(1))^2 - c4);
      zdot(3) = z(4);
      top4 = u + c2*sin(z(1))*z(2)^2 - c3*cos(z(1))*sin(z(1));
      zdot(4) = top4/(c1-m*cos(z(1))^2);
% 
%   end of routine
